#!/usr/bin/python3
# -*- coding: utf-8 -*-
from zsub.common.request import Request
from zsub.commands.info import info
from zsub.commands.config import config
from zsub.commands.unzip import unzip
from zsub.commands.dl import dl
from zsub.commands.batch import batch
from zsub.commands.clean import clean
from zsub.commands.login import login
from zsub.commands.update import update

def main():
    try:
        req = Request()
        update(req, auto=True)
        if req.command == "info":
            info(req)
        elif req.command == 'config':
            config(req)
        elif req.command == 'unzip':
            unzip(req)
        elif req.command == 'dl':
            dl(req)
        elif req.command == 'batch':
            batch(req)
        elif req.command == 'clean':
            clean(req)
        elif req.command == 'login':
            login(req)
        elif req.command == 'update':
            update(req)
    except KeyboardInterrupt:
        print('\n'*2 + '[Exit] Terminated by user.' + '\n')
        exit()
