from zsub.common.search import cache_search
from zsub.common.utils import empty, delete, delete_if_empty, clean_root
from zsub.common.utils import get_size, byte_equivalent, human_readable, count_grandchildren


def clean(req):
    root = req.cache.joinpath('subtitles')
    clean_root(root)
    size_b = byte_equivalent(get_size(root))
    to_clean = cache_search(req.title, req.languages.fulls, req.cache)
    if req.zero:
        print('\n[emptying]')
        for path in to_clean:
            empty(path)
        size_a = byte_equivalent(get_size(root))
        print(f"\n{human_readable(size_b-size_a)} freed by emptying files.\n")
    else:
        print('\n[deleting]')
        for path in to_clean:
            delete(path)
            delete_if_empty(path.parent)
        size_a = byte_equivalent(get_size(root))
        print(f"\n{human_readable(size_b-size_a)} freed by deleting files.\n")