LANGUAGES = {
    "ar": "arabic",
    "da": "danish",
    "en": "english",
    "es": "spanish",
    "fa": "farsi_persian",
    "fr": "french",
    "he": "hebrew",
    "id": "indonesian",
    "it": "italian",
    "no": "norwegian",
    "sv": "swedish",
    "vi": "vietnamese",
    "big5": "big_5_code"
}

LNGS = {value: key for key, value in LANGUAGES.items()}

def parse(lngs):
    langs = list()
    for lng in lngs:
        if is_valid(lng):
            if lng not in langs:
                langs.append(lng)
        else:
            print(f'Warning: "{lng}" is not a valid language abbr. Ignored.')
    if not(langs):
        langs = list('en')
    return langs

def abbr2full(lng):
    return LANGUAGES[lng]

def full2abbr(language):
    return LNGS[language]

def all_langs():
    return list(LANGUAGES.keys())

def is_valid(lng):
    return lng in all_langs()

def get_lang(file_path):
    language = file_path.parent.name
    if language == 'farsi_persian':
        language = 'farsi'
    return language


class Language:
    def __init__(self, *langs):
        self.abbrs = parse(langs)
        self.fulls = [abbr2full(lng) for lng in self.abbrs]
