from zsub.common.utils import lpad


def get_user_choice(results):
    mx = len(results)
    while True:
        if mx == 1:
            text = "Press Enter to select only result"
        else:
            text = "Enter a number or comma separated numbers for multiple choice.\nnumbers must be between (1-" + str(mx) + ")"

        print(' '*2 + text, end='')
        try:
            selected = input(' [1]: ') or '1'
            answer = filter_valid_choice(selected, mx)
            if answer:
                return answer
            else:
                raise IndexError
        except KeyboardInterrupt:
            print('\n'*2 + '[Exit] Terminated by user.' + '\n')
            exit()
        except IndexError:
            print("  Oops! not valid. try again:")

def select(results, auto_select):
    if not results:
        return []
    else:
        print('[Select]')
        mx = len(results)
        for i, res in enumerate(results):
            print('  ' + lpad(i+1, mx) + ' - ' + res['title'])

        if auto_select:
            print(' '*2 + '....auto select....')
            selected = [1,]
        else:
            print(' '*2 + '...................')
            selected = get_user_choice(results)
            print(' '*2 + '....your choice....')
        return selected

def filter_valid_choice(text, maximum):
    numbers = text.split(',')
    numbers = [int(n) for n in numbers if is_valid_integer(n)]
    return list(set([n for n in numbers if (0 < n < 1+maximum)]))

def is_valid_integer(i):
    try:
        int(i)
        return True
    except ValueError:
        return False