from zsub.mirrors.subf2m import Subf2m as subf2mMIRROR
from zsub.mirrors.subscene import Subscene as subsceneMIRROR
from zsub.mirrors.xyz import XYZ as xyzMIRROR
from zsub.mirrors.hastisub import Hastisub as hastisubMIRROR


MIRRORS = [
    klass().name
    for name, klass in globals().items()
    if name.endswith('MIRROR')
]

def get_mirror_class(mirror_name):
    """Returns the mirror class with the given mirror_name"""
    return globals()[mirror_name + 'MIRROR']

def get_mirror(name):
    if name not in MIRRORS:
        print(f'Warning: "{name}" is not supported. "subscene" is selected.')
        name = 'subscene'
    return get_mirror_class(name)()
